import es, popuplib, playerlib, cmdlib, os, gamethread

info = es.AddonInfo()
info.name = 'DonatorB'
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/DonatorB'
info.basename = 'donator'
info.author = 'Deathyy'

es.ServerVar('donatorb_ver', info['version'], 'A simple but dynamic donator mod.').makepublic()

allow_respawn = 1

donators = [
    'STEAM_0:1:25511182',
    'STEAM_ID_LAN',
    'STEAM_ID_PENDING',
    'STEAM_0:0:00000000',
    'STEAM_1:1:11111111'
    ]
    
mapListPath = os.path.join( str(es.ServerVar("eventscripts_gamedir")), "maplist.txt")
fileHandle = open(mapListPath, "rb")
fileLines = fileHandle.readlines()
fileHandle.close()

maps = filter(bool, map(lambda x: x[:x.find("//")] if x.find("//") > -1 else x, map(lambda x: x.strip(), fileLines)))

def load():
    global donator_home, donator_chat_and_console_commands, donator_fun_commands, donator_map_management, donator_credits, donator_free_weapons, donator_free_weapons_primarys, donator_free_weapons_primarys2, donator_free_weapons_primarys3, donator_free_weapons_secondarys, donator_free_weapons_equiptment
    
    cmdlib.registerSayCommand('!donator', donator_open_select, 'Chat Command to Open Menu')
    cmdlib.registerClientCommand('donator_open', donator_open_select, 'Console Command to Open Menu')
    
    cmdlib.registerSayCommand('!respawn', donator_respawn_select, 'Chat Command to Respawn')
    cmdlib.registerClientCommand('donator_respawn', donator_respawn_select, 'Console Command to Respawn')
    
    cmdlib.registerSayCommand('!god', donator_god_select, 'Chat Command to God')
    cmdlib.registerClientCommand('donator_god', donator_god_select, 'Console Command to God')
    
    cmdlib.registerSayCommand('!noclip', donator_noclip_select, 'Chat Command to Noclip')
    cmdlib.registerClientCommand('donator_noclip', donator_noclip_select, 'Console Command to Noclip')
    
    cmdlib.registerSayCommand('!jetpack', donator_jetpack_select, 'Chat Command to Jetpack')
    cmdlib.registerClientCommand('donator_jetpack', donator_jetpack_select, 'Console Command to Jetpack')
    
    cmdlib.registerSayCommand('!speed', donator_speed_select, 'Chat Command to Speed')
    cmdlib.registerClientCommand('donator_speed', donator_speed_select, 'Console Command to Speed')
    
    
    donator_home = popuplib.create('donator_home')
    a = donator_home.addline
    a('Donator v1.0')
    a('->1. Chat & Console Commands')
    a('->2. Fun Commands')
    a('->3. Free Weapons')
    a('->4. Map Management')
    a('->5. Credits')
    a('0 Exit')
    donator_home.menuselect = donator_home_select
    
    donator_chat_and_console_commands = popuplib.create('donator_chat_and_console_commands')
    a = donator_chat_and_console_commands.addline
    a('Chat & Console Commands')
    a('-----------------------')
    a('Open Donator Menu - Chat : !donator, Console : donator_open')
    a('Respawn - Chat : !respawn, Console : donator_respawn')
    a('God Mode - Chat : !god, Console : donator_god')
    a('Noclip - Chat : !noclip, Console : donator_noclip')
    a('Jetpack - Chat : !jetpack, Console : donator_jetpack')
    a('Speed - Chat : !speed, Console : donator_speed')
    a('->8. Back')
    a('-----------------------')
    a('0 Exit')
    donator_chat_and_console_commands.menuselect = donator_chat_and_console_commands_select
    
    donator_fun_commands = popuplib.create('donator_fun_commands')
    a = donator_fun_commands.addline
    a('Fun Commands')
    a('->1. Respawn')
    a('->2. God')
    a('->3. Noclip')
    a('->4. Jetpack')
    a('->5. Speed')
    a('->8. Back')
    a('0 Exit')
    donator_fun_commands.menuselect = donator_fun_commands_select
    
    donator_map_management = popuplib.create('donator_map_management')
    a = donator_map_management.addline
    a('Map Management')
    a('->1. Change Map')
    a('->2. Set Next Map')
    a('->8. Back')
    a('0 Exit')
    donator_map_management.menuselect = donator_map_management_select
    
    donator_credits = popuplib.create('donator_credits')
    a = donator_credits.addline
    a('Credits')
    a('------------------------------')
    a('Author : Deathyy')
    a('Helpers : Undead')
    a('Version : 1.0')
    a('Language : English')
    a('Coding Language : Python')
    a('Date Released : July 15th 2010')
    a('------------------------------')
    a('->8. Back')
    a('0 Exit')
    donator_credits.menuselect = donator_credits_select
    
    donator_free_weapons = popuplib.create('donator_free_weapons')
    a = donator_free_weapons.addline
    a('Free Weapons')
    a('->1. Primarys')
    a('->2. Secondarys')
    a('->3. Equiptment')
    a('->8. Back')
    a('0 Exit')
    donator_free_weapons.menuselect = donator_free_weapons_select
    
    donator_free_weapons_primarys = popuplib.create('donator_free_weapons_primarys')
    a = donator_free_weapons_primarys.addline
    a('Primarys 1/3')
    a('->1. M4a1')
    a('->2. Ak47')
    a('->3. Awp')
    a('->4. Galil')
    a('->5. Famas')
    a('->6. Sg550')
    a('->7. AUG')
    a('->8. Back')
    a('->9. Next')
    a('0 Exit')
    donator_free_weapons_primarys.menuselect = donator_free_weapons_primarys_select
    
    donator_free_weapons_primarys2 = popuplib.create('donator_free_weapons_primarys2')
    a = donator_free_weapons_primarys2.addline
    a('Primarys 2/3')
    a('->1. Tmp')
    a('->2. M3')
    a('->3. Xm1014')
    a('->4. Mp5navy')
    a('->5. Ump45')
    a('->6. Scout')
    a('->7. Sg552')
    a('->8. Back')
    a('->9. Next')
    a('0 Exit')
    donator_free_weapons_primarys2.menuselect = donator_free_weapons_primarys2_select
    
    donator_free_weapons_primarys3 = popuplib.create('donator_free_weapons_primarys3')
    a = donator_free_weapons_primarys3.addline
    a('Primarys 3/3')
    a('->1. G3sg1')
    a('->2. M249')
    a('->3. Mac10')
    a('->4. P90')
    a('->8. Back')
    a('0 Exit')
    donator_free_weapons_primarys3.menuselect = donator_free_weapons_primarys3_select
    
    donator_free_weapons_secondarys = popuplib.create('donator_free_weapons_secondarys')
    a = donator_free_weapons_secondarys.addline
    a('Secondarys')
    a('->1. Glock')
    a('->2. Usp')
    a('->3. P228')
    a('->4. Deagle')
    a('->5. Fiveseven')
    a('->6. Dual Elites')
    a('->8. Back')
    a('0 Exit')
    donator_free_weapons_secondarys.menuselect = donator_free_weapons_secondarys_select
    
    donator_free_weapons_equiptment = popuplib.create('donator_free_weapons_equiptment')
    a = donator_free_weapons_equiptment.addline
    a('Equiptment')
    a('->1. He Grenade')
    a('->2. Flashbang')
    a('->3. Smokegrenade')
    a('->4. Nightvision')
    a('->8. Back')
    a('0 Exit')
    donator_free_weapons_equiptment.menuselect = donator_free_weapons_equiptment_select
     
def unload():
    cmdlib.unregisterSayCommand('!donator')
    cmdlib.unregisterClientCommand('donator_open')
    cmdlib.unregisterSayCommand('!respawn')
    cmdlib.unregisterClientCommand('donator_respawn')
    cmdlib.unregisterSayCommand('!god')
    cmdlib.unregisterClientCommand('donator_god')
    cmdlib.unregisterSayCommand('!noclip')
    cmdlib.unregisterClientCommand('donator_noclip')
    cmdlib.unregisterSayCommand('!jetpack')
    cmdlib.unregisterClientCommand('donator_jetpack')
    cmdlib.unregisterSayCommand('!speed')
    cmdlib.unregisterClientCommand('donator_speed')
    
def player_spawn(ev):
    player = playerlib.getPlayer(ev['userid'])
    player.set('noclip', 0)
    player.godmode(0)
    
def donator_open_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if steamid in donators:
        donator_home.send(userid)
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
        
def donator_respawn_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if allow_respawn == 1:
        if steamid in donators:
            es.setplayerprop(userid, 'CCSPlayer.m_iPlayerState', 0)
            es.setplayerprop(userid, 'CCSPlayer.baseclass.m_lifeState', 512)
            es.spawnplayer(userid)
            es.tell(userid, '#multi', '#green[Donator] #defaultYou have respawned yourself.')
        else:
            es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultRespawning is disabled.')
        
def donator_god_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if steamid in donators:
        player = playerlib.getPlayer(userid)
        if player.inGodMode():
            player.godmode(0)
            es.tell(userid, '#multi', '#green[Donator] #defaultGod Mode : Off')
        else:
            player.godmode(1)
            es.tell(userid, '#multi', '#green[Donator] #defaultGod Mode : On')
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
        
def donator_noclip_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if steamid in donators:
        player = playerlib.getPlayer(userid)
        if player.getNoClip():
            player.set('noclip', 0)
            es.tell(userid, '#multi', '#green[Donator] #defaultNoClip : Off')
        else:
            player.set('noclip', 1)
            es.tell(userid, '#multi', '#green[Donator] #defaultNoClip : On')
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
        
def donator_jetpack_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if steamid in donators:
        player = playerlib.getPlayer(userid)
        if player.getJetpack():
            player.set('jetpack', 0)
            es.tell(userid, '#multi', '#green[Donator] #defaultJetpack : Off')
        else:
            player.set('jetpack', 1)
            es.tell(userid, '#multi', '#green[Donator] #defaultJetpack : On')
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
            
def donator_speed_select(userid, ev):
    steamid = es.getplayersteamid(userid)
    if steamid in donators:
        player = playerlib.getPlayer(userid)
        if player.getSpeed() == 1:
            player.set('speed', 1.5)
            es.tell(userid, '#multi', '#green[Donator] #defaultSpeed set to x1.5')
        else:
            player.set('speed', 1.0)
            es.tell(userid, '#multi', '#green[Donator] #defaultSpeed set to x1.0')
    else:
        es.tell(userid, '#multi', '#green[Donator] #defaultYou are no DONATOR!')
            
            
def donator_fun_commands_select(userid, choice, popupid):
    if choice == 1:
        es.sexec(userid, 'say !respawn')
        donator_fun_commands.send(userid)
    elif choice == 2:
        es.sexec(userid, 'say !god')
        donator_fun_commands.send(userid)
    elif choice == 3:
        es.sexec(userid, 'say !noclip')
        donator_fun_commands.send(userid)
    elif choice == 4:
        es.sexec(userid, 'say !jetpack')
        donator_fun_commands.send(userid)
    elif choice == 5:
        es.sexec(userid, 'say !speed')
        donator_fun_commands.send(userid)
    elif choice == 8:
        donator_home.send(userid)
        
def donator_home_select(userid, choice, popupid):
    if choice == 1:
        donator_chat_and_console_commands.send(userid)
    elif choice == 2:
        donator_fun_commands.send(userid)
    elif choice == 3:
        donator_free_weapons.send(userid)
    elif choice == 4:
        donator_map_management.send(userid)
    elif choice == 5:
        donator_credits.send(userid)
        
def donator_chat_and_console_commands_select(userid, choice, popupid):
    if choice < 8:
        donator_chat_and_console_commands.send(userid)
    elif choice == 8:
        donator_home.send(userid)
        
def donator_map_management_select(userid, choice, popupid):
    if choice == 1:
        map_change.send(userid)
    elif choice == 2:
        map_set.send(userid)
        
def changeMap(userid, choice, popupid):
    es.msg('#multi', '#green[Donator] #defaultMap changing to %s'%choice)
    gamethread.delayed(2, es.server.queuecmd, ('changelevel %s'%choice))
    
def setMap(userid, choice, popupid):
    name = es.getplayername(userid)
    es.msg('#multi', '#green[Donator] #default%s has set the next map to %s'% (name, choice))
    es.server.queuecmd('nextlevel %s'%choice)
    
def donator_credits_select(userid, choice, popupid):
    if choice < 8:
        donator_credits.send(userid)
    elif choice == 8:
        donator_home.send(userid)
        
def donator_free_weapons_select(userid, choice, popupid): 
    if choice == 1:
        donator_free_weapons_primarys.send(userid)
    elif choice == 2:
        donator_free_weapons_secondarys.send(userid)
    elif choice == 3:
        donator_free_weapons_equiptment.send(userid)
    elif choice == 8:
        donator_home.send(userid)
        
def donator_free_weapons_primarys_select(userid, choice, popupid):
    if choice == 1:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_m4a1'%userid))
        donator_free_weapons.send(userid)
    elif choice == 2:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_ak47'%userid))
        donator_free_weapons.send(userid)
    elif choice == 3:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_awp'%userid))
        donator_free_weapons.send(userid)
    elif choice == 4:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_galil'%userid))
        donator_free_weapons.send(userid)
    elif choice == 5:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_famas'%userid))
        donator_free_weapons.send(userid)
    elif choice == 6:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_sg550'%userid))
        donator_free_weapons.send(userid)
    elif choice == 7:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_aug'%userid))
        donator_free_weapons.send(userid)
    elif choice == 8:
        donator_free_weapons.send(userid)
    elif choice == 9:
        donator_free_weapons_primarys2.send(userid)
        
def donator_free_weapons_primarys2_select(userid, choice, popupid):
    if choice == 1:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_tmp'%userid))
        donator_free_weapons.send(userid)
    elif choice == 2:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_m3'%userid))
        donator_free_weapons.send(userid)
    elif choice == 3:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_xm1014'%userid))
        donator_free_weapons.send(userid)
    elif choice == 4:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_mp5navy'%userid))
        donator_free_weapons.send(userid)
    elif choice == 5:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_ump45'%userid))
        donator_free_weapons.send(userid)
    elif choice == 6:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_scout'%userid))
        donator_free_weapons.send(userid)
    elif choice == 7:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_sg552'%userid))
        donator_free_weapons.send(userid)
    elif choice == 8:
        donator_free_weapons_primarys.send(userid)
    elif choice == 9:
        donator_free_weapons_primarys3.send(userid)
        
def donator_free_weapons_primarys3_select(userid, choice, popupid):
    if choice == 1:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_g3sg1'%userid))
        donator_free_weapons.send(userid)
    elif choice == 2:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_m249'%userid))
        donator_free_weapons.send(userid)
    elif choice == 3:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_mac10'%userid))
        donator_free_weapons.send(userid)
    elif choice == 4:
        es.server.queuecmd('est_removeweapon %s 1'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_p90'%userid))
        donator_free_weapons.send(userid)
    elif choice == 8:
        donator_free_weapons_primarys2.send(userid)
    
def donator_free_weapons_secondarys_select(userid, choice, popupid):
    if choice == 1:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_glock'%userid))
        donator_free_weapons.send(userid)
    elif choice == 2:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_usp'%userid))
        donator_free_weapons.send(userid)
    elif choice == 3:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_p228'%userid))
        donator_free_weapons.send(userid)
    elif choice == 4:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_deagle'%userid))
        donator_free_weapons.send(userid)
    elif choice == 5:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_fiveseven'%userid))
        donator_free_weapons.send(userid)
    elif choice == 6:
        es.server.queuecmd('est_removeweapon %s 2'%userid)
        gamethread.delayed(0, es.server.queuecmd, ('es_give %s weapon_elite'%userid))
        donator_free_weapons.send(userid)
    elif choice == 8:
        donator_free_weapons.send(userid)
        
def donator_free_weapons_equiptment_select(userid, choice, popupid):
    if choice == 1:
        es.server.queuecmd('es_give %s weapon_hegrenade'%userid)
        donator_free_weapons.send(userid)
    elif choice == 2:
        es.server.queuecmd('es_give %s weapon_flashbang'%userid)
        donator_free_weapons.send(userid)
    elif choice == 3:
        es.server.queuecmd('es_give %s weapon_smokegrenade'%userid)
        donator_free_weapons.send(userid)
    elif choice == 4:
        es.server.queuecmd('es_give %s item_nvgs'%userid)
        donator_free_weapons.send(userid)
    elif choice == 8:
        donator_free_weapons.send(userid)
    
map_change = popuplib.easymenu('Select map to change level to:', 'choice', changeMap)
for mapname in maps:
    map_change.addoption(mapname, mapname)
    
map_set = popuplib.easymenu('Select next Map:', 'choice', setMap)
for mapname in maps:
    map_set.addoption(mapname, mapname)